%{
  #include <string.h>
  #include <stdio.h>
  char str[1000];
%}

positivt_tal    [0-9]+
tal             (-)?{positivt_tal}
heltalsspec     \%{tal}?d
flyttalsspec    \%{tal}?(.{positivt_tal})?f
strspec         \%{tal}?(.{positivt_tal})?s
procentsak      {heltalsspec}|{flyttalsspec}|{strspec}
vanligt_tecken  [^\%]
sak             {vanligt_tecken}|{procentsak}
format          {sak}*

%%

{format}	{ strcpy(str, yytext); return 97; }
.		{ strcpy(str, yytext); return -1; }

%%

int main() {
  while (1) {
    int t = yylex();
    printf("t = %d, str = '%s'\n", t, str);
  }
  return 0;
}

int yywrap() {
  printf("Calling yywrap...\n");
  return 1;
}
